/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2016  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef ENCODERSIMULATIONHEADERFILE
#define ENCODERSIMULATIONHEADERFILE

#include <QDialog>

#include "encoderchannel.h"
#include "encoderinterpolator.h"

class QComboBox;
class QDoubleSpinBox;
class QPlainTextEdit;
class QTabWidget;
class QLabel;
class QToolButton;
class TGraphWidget;

class TEncoderSimulation : public QDialog
{
Q_OBJECT

public:

// CREATORS
	TEncoderSimulation(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TEncoderSimulation(void);

// ACCESSORS

// MANIPULATORS

signals:

private slots:
	void Gain_A(const double);
	void Gain_B(const double);
	void Offset_A(const double);
	void Offset_B(const double);
	void Phase_A(const double);
	void Phase_B(const double);
	void Setup_Changed(void);
	void Scope_Mode_Changed(bool);

private:
	QComboBox							*d_setup_pitch_combo;
	QComboBox							*d_setup_resolution_combo;
	QDoubleSpinBox						*d_setup_gaina_spin;
	QDoubleSpinBox						*d_setup_gainb_spin;
	QDoubleSpinBox						*d_setup_offseta_spin;
	QDoubleSpinBox						*d_setup_offsetb_spin;
	QDoubleSpinBox						*d_setup_phasea_spin;
	QDoubleSpinBox						*d_setup_phaseb_spin;
	QLabel								*d_output_status_label;
	QPlainTextEdit						*d_output_text_edit;
	QTabWidget							*d_output_view_tab;
	TGraphWidget						*d_output_graph_widget;
	TGraphWidget						*d_signal_graph_widget;
	QToolButton							*d_graph_mode_button;
	
	TEncoderChannel						d_channel_a;
	TEncoderChannel						d_channel_b;
	TEncoderInterpolator				d_interpolator;
	
	void Update_Encoder_Signal(void);
	void Update_Interpolator_Output(void);

// NOT IMPLEMENTED
	TEncoderSimulation(const TEncoderSimulation&);
	TEncoderSimulation operator=(const TEncoderSimulation&);
};

#endif
